*** sendmail-8.12.11/sendmail/conf.c	2004/03/04 14:41:00	1.1
--- sendmail-8.12.11/sendmail/conf.c	2004/03/04 15:02:22
***************
*** 514,519 ****
--- 514,526 ----
  		ldapmap_lookup, null_map_store);
  #endif /* LDAPMAP */
  
+ #ifdef FSTATMAP
+ 	/* fstat map - check file/path using stat function */
+ 	MAPDEF("fstat", NULL, 0,
+ 		dequote_init, null_map_open, null_map_close,
+ 		fstat_map_lookup, null_map_store);
+ #endif /* FSTATMAP */
+ 
  #if PH_MAP
  	MAPDEF("ph", NULL, MCF_NOTPERSIST,
  		ph_map_parseargs, ph_map_open, ph_map_close,
***************
*** 5553,5558 ****
--- 5560,5570 ----
  #if LDAPMAP
  	"LDAPMAP",
  #endif /* LDAPMAP */
+ #if FSTATMAP
+ 	/* Andrzej Filip */
+ 	/* fstat map - check file/path using stat function */
+ 	"FSTATMAP",
+ #endif /* FSTATMAP */
  #if LOG
  	"LOG",
  #endif /* LOG */
*** sendmail-8.12.11/sendmail/map.c	2004/03/04 14:41:17	1.1
--- sendmail-8.12.11/sendmail/map.c	2004/03/04 15:02:55
***************
*** 7300,7305 ****
--- 7300,7381 ----
  }
  #endif /* MAP_NSD */
  
+ #if FSTATMAP
+ char *
+ fstat_map_lookup(map, name, av, statp)
+ 	MAP *map;
+ 	char *name;
+ 	char **av;
+ 	int *statp;
+ {
+ 	long r;
+ 	bool res = false;
+ 	bool boolres;
+ 	static char result[16];
+ 	char **cpp;
+ 	struct stat st;
+ 	
+ 	if (tTd(38, 2))
+ 	{
+ 		sm_dprintf("fstat_map_lookup: key '%s'\n", name);
+ 		for (cpp = av; cpp != NULL && *cpp != NULL; cpp++)
+ 			sm_dprintf("fstat_map_lookup: arg '%s'\n", *cpp);
+ 	}
+ 	r = 0;
+ 	boolres = true;
+ 	*statp = EX_OK;
+ 	if (name != NULL && av != NULL && av[0] != NULL && av[1] != NULL )
+ 	{
+ 		errno = 0;
+ 		if (stat(av[1], &st) < 0)
+ 		{
+ 			switch (errno)
+ 			{
+ 				/* It does not exist */
+ 				case ENOENT:
+ 					return NULL;
+ 			}
+ 			*statp = EX_TEMPFAIL;
+ 			return NULL;
+ 		}
+ 		switch (*name)
+ 		{
+ 		  case 'd':
+ 			res = S_ISDIR(st.st_mode);
+ 			break;
+ 		  case 'f':
+ 			res = S_ISREG(st.st_mode);
+ 			break;
+ 		  case 's':
+ 			boolres = false;
+ 			r = st.st_size;
+ 			break;
+ 		  default:
+ 			/* XXX */
+ 			*statp = EX_CONFIG;
+ 			if (LogLevel > 10)
+ 				sm_syslog(LOG_WARNING, NOQID,
+ 					  "fstat_map: unknown operator %c",
+ 					  isprint(*name) ? *name : '?');
+ 			return NULL;
+ 		}
+ 			
+ 		if (boolres)
+ 		{
+ 			if(res)
+ 				(void) sm_snprintf(result, sizeof result, "OK");
+ 			else
+ 				return NULL;
+ 		}
+ 		else
+ 			(void) sm_snprintf(result, sizeof result, "%ld", r);
+ 		return result;
+ 	}
+ 	*statp = EX_CONFIG;
+ 	return NULL;
+ }
+ #endif /* FSTATMAP */
+ 
  char *
  arith_map_lookup(map, name, av, statp)
  	MAP *map;
